# all files / ol/ mapbrowserevent.js

76.61% Statements 95/124
47.06% Branches 16/34
66.67% Functions 10/15
76.61% Lines 95/124

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    375
    376
    377
    378
    379
    380
    381
    382
    383
    384
    385
    386
    387
    388
    389
    390
    391
    392
    393
    394
    395
    396
    397
    398
    399
    400
    401
    402
    403
    404
    405
    406
    407
    408
    409
    410
    411
    412
    413
    414
    415
    416
    417
    418
    419
    420
    421
    422
    423
    424
    425
    426
    427
    428
    429
    430
    431
    432
    433
    434
    435
    436
    437
    438
    439
    440
    441
    442
    443
    444
    445
    446
    447
    448
    449
    450
    451
    452
    453
    454
    455
    456
    457
    458
    459
    460
    461
    462
    463
    464
    465
    466
    467
    468
    469
    470
    471
    472
    473
    474
    475
    476
    477
    478
    479
    480
    481
    482
    483
    484
    485
    486
    487
    488
    489
    490
    491
    492
    493
    4941×
    1×
    1×
    1×

    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    242×

    242×

    242×

    242×

    242×

    242×

    1×

    1×

    1×

    1×

    242×

    242×

    1×

    1×

    125×

    125×

    125×

    125×

    125×

    125×

    125×

    125×

    125×

    125×

    125×

    125×

    125×

    125×

    1×

    1×
    5×
    5×

    5×
    5×

    1×
    1×
    1×

    1×

    4×
    1×
    1×

    1×

    1×

    1×

    1×

    1×
    1×

    1×

    1×

    1×

    1×

    1×
    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
    1×

    1×
    87×
    87×
    87×

    87×
    87×
    87×

    87×

    87×

    87×
    87×
    87×

    87×

    1×

     goog.provide('ol.MapBrowserEvent');
    goog.provide('ol.MapBrowserEvent.EventType');
    goog.provide('ol.MapBrowserEventHandler');
    goog.provide('ol.MapBrowserPointerEvent');

    goog.require('goog.asserts');
    goog.require('goog.events');
    goog.require('goog.events.BrowserEvent');
    goog.require('goog.events.EventTarget');
    goog.require('goog.events.EventType');
    goog.require('goog.object');
    goog.require('ol');
    goog.require('ol.Coordinate');
    goog.require('ol.MapEvent');
    goog.require('ol.Pixel');
    goog.require('ol.pointer.PointerEvent');
    goog.require('ol.pointer.PointerEventHandler');

    /**
     * @classdesc
     * Events emitted as map browser events are instances of this type.
     * See {@link ol.Map} for which events trigger a map browser event.
     *
     * @constructor
     * @extends {ol.MapEvent}
     * @implements {oli.MapBrowserEvent}
     * @param {string} type Event type.
     * @param {ol.Map} map Map.
     * @param {goog.events.BrowserEvent} browserEvent Browser event.
     * @param {boolean=} opt_dragging Is the map currently being dragged?
     * @param {?olx.FrameState=} opt_frameState Frame state.
     */
    ol.MapBrowserEvent = function(type, map, browserEvent, opt_dragging,
        opt_frameState) {

      goog.base(this, type, map, opt_frameState);

      /**
       * @const
       * @type {goog.events.BrowserEvent}
       */
      this.browserEvent = browserEvent;

      /**
       * The original browser event.
       * @const
       * @type {Event}
       * @api stable
       */
      this.originalEvent = browserEvent.getBrowserEvent();

      /**
       * The pixel of the original browser event.
       * @type {ol.Pixel}
       * @api stable
       */
      this.pixel = map.getEventPixel(this.originalEvent);

      /**
       * The coordinate of the original browser event.
       * @type {ol.Coordinate}
       * @api stable
       */
      this.coordinate = map.getCoordinateFromPixel(this.pixel);

      /**
       * Indicates if the map is currently being dragged. Only set for
       * `POINTERDRAG` and `POINTERMOVE` events. Default is `false`.
       *
       * @type {boolean}
       * @api stable
       */
      this.dragging = opt_dragging !== undefined ? opt_dragging : false;

    };
    goog.inherits(ol.MapBrowserEvent, ol.MapEvent);

    /**
     * Prevents the default browser action.
     * @see https://developer.mozilla.org/en-US/docs/Web/API/event.preventDefault
     * @override
     * @api stable
     */
    ol.MapBrowserEvent.prototype.preventDefault = function() {
      goog.base(this, 'preventDefault');
      this.browserEvent.preventDefault();
    };

    /**
     * Prevents further propagation of the current event.
     * @see https://developer.mozilla.org/en-US/docs/Web/API/event.stopPropagation
     * @override
     * @api stable
     */
    ol.MapBrowserEvent.prototype.stopPropagation = function() {
      goog.base(this, 'stopPropagation');
      this.browserEvent.stopPropagation();
    };

    /**
     * @constructor
     * @extends {ol.MapBrowserEvent}
     * @param {string} type Event type.
     * @param {ol.Map} map Map.
     * @param {ol.pointer.PointerEvent} pointerEvent Pointer event.
     * @param {boolean=} opt_dragging Is the map currently being dragged?
     * @param {?olx.FrameState=} opt_frameState Frame state.
     */
    ol.MapBrowserPointerEvent = function(type, map, pointerEvent, opt_dragging,
        opt_frameState) {

      goog.base(this, type, map, pointerEvent.browserEvent, opt_dragging,
          opt_frameState);

      /**
       * @const
       * @type {ol.pointer.PointerEvent}
       */
      this.pointerEvent = pointerEvent;

    };
    goog.inherits(ol.MapBrowserPointerEvent, ol.MapBrowserEvent);

    /**
     * @param {ol.Map} map The map with the viewport to listen to events on.
     * @constructor
     * @extends {goog.events.EventTarget}
     */
    ol.MapBrowserEventHandler = function(map) {

      goog.base(this);

      /**
       * This is the element that we will listen to the real events on.
       * @type {ol.Map}
       * @private
       */
      this.map_ = map;

      /**
       * @type {number}
       * @private
       */
      this.clickTimeoutId_ = 0;

      /**
       * @type {boolean}
       * @private
       */
      this.dragging_ = false;

      /**
       * @type {Array.<goog.events.Key>}
       * @private
       */
      this.dragListenerKeys_ = null;

      /**
       * @type {goog.events.Key}
       * @private
       */
      this.pointerdownListenerKey_ = null;

      /**
       * The most recent "down" type event (or null if none have occurred).
       * Set on pointerdown.
       * @type {ol.pointer.PointerEvent}
       * @private
       */
      this.down_ = null;

      var element = this.map_.getViewport();

      /**
       * @type {number}
       * @private
       */
      this.activePointers_ = 0;

      /**
       * @type {Object.<number, boolean>}
       * @private
       */
      this.trackedTouches_ = {};

      /**
       * Event handler which generates pointer events for
       * the viewport element.
       *
       * @type {ol.pointer.PointerEventHandler}
       * @private
       */
      this.pointerEventHandler_ = new ol.pointer.PointerEventHandler(element);

      /**
       * Event handler which generates pointer events for
       * the document (used when dragging).
       *
       * @type {ol.pointer.PointerEventHandler}
       * @private
       */
      this.documentPointerEventHandler_ = null;

      this.pointerdownListenerKey_ = goog.events.listen(this.pointerEventHandler_,
          ol.pointer.EventType.POINTERDOWN,
          this.handlePointerDown_, false, this);

      this.relayedListenerKey_ = goog.events.listen(this.pointerEventHandler_,
          ol.pointer.EventType.POINTERMOVE,
          this.relayEvent_, false, this);

    };
    goog.inherits(ol.MapBrowserEventHandler, goog.events.EventTarget);

    /**
     * @param {ol.pointer.PointerEvent} pointerEvent Pointer event.
     * @private
     */
    ol.MapBrowserEventHandler.prototype.emulateClick_ = function(pointerEvent) {
      var newEvent;
      newEvent = new ol.MapBrowserPointerEvent(
          ol.MapBrowserEvent.EventType.CLICK, this.map_, pointerEvent);
      this.dispatchEvent(newEvent);
      if (this.clickTimeoutId_ !== 0) {
        // double-click
        goog.global.clearTimeout(this.clickTimeoutId_);
        this.clickTimeoutId_ = 0;
        newEvent = new ol.MapBrowserPointerEvent(
            ol.MapBrowserEvent.EventType.DBLCLICK, this.map_, pointerEvent);
        this.dispatchEvent(newEvent);
      } else {
        // click
        this.clickTimeoutId_ = goog.global.setTimeout(goog.bind(function() {
          this.clickTimeoutId_ = 0;
          var newEvent = new ol.MapBrowserPointerEvent(
              ol.MapBrowserEvent.EventType.SINGLECLICK, this.map_, pointerEvent);
          this.dispatchEvent(newEvent);
        }, this), 250);
      }
    };

    /**
     * Keeps track on how many pointers are currently active.
     *
     * @param {ol.pointer.PointerEvent} pointerEvent Pointer event.
     * @private
     */
    ol.MapBrowserEventHandler.prototype.updateActivePointers_ =
        function(pointerEvent) {
      var event = pointerEvent;

      Iif (event.type == ol.MapBrowserEvent.EventType.POINTERUP ||
          event.type == ol.MapBrowserEvent.EventType.POINTERCANCEL) {
        delete this.trackedTouches_[event.pointerId];
      } else Eif (event.type == ol.MapBrowserEvent.EventType.POINTERDOWN) {
        this.trackedTouches_[event.pointerId] = true;
      }
      this.activePointers_ = goog.object.getCount(this.trackedTouches_);
    };

    /**
     * @param {ol.pointer.PointerEvent} pointerEvent Pointer event.
     * @private
     */
    ol.MapBrowserEventHandler.prototype.handlePointerUp_ = function(pointerEvent) {
      this.updateActivePointers_(pointerEvent);
      var newEvent = new ol.MapBrowserPointerEvent(
          ol.MapBrowserEvent.EventType.POINTERUP, this.map_, pointerEvent);
      this.dispatchEvent(newEvent);

      // We emulate click events on left mouse button click, touch contact, and pen
      // contact. isMouseActionButton returns true in these cases (evt.button is set
      // to 0).
      // See http://www.w3.org/TR/pointerevents/#button-states
      if (!this.dragging_ && this.isMouseActionButton_(pointerEvent)) {
        goog.asserts.assert(this.down_, 'this.down_ must be truthy');
        this.emulateClick_(this.down_);
      }

      goog.asserts.assert(this.activePointers_ >= 0,
          'this.activePointers_ should be equal to or larger than 0');
      if (this.activePointers_ === 0) {
        this.dragListenerKeys_.forEach(goog.events.unlistenByKey);
        this.dragListenerKeys_ = null;
        this.dragging_ = false;
        this.down_ = null;
        goog.dispose(this.documentPointerEventHandler_);
        this.documentPointerEventHandler_ = null;
      }
    };

    /**
     * @param {ol.pointer.PointerEvent} pointerEvent Pointer event.
     * @return {boolean} If the left mouse button was pressed.
     * @private
     */
    ol.MapBrowserEventHandler.prototype.isMouseActionButton_ =
        function(pointerEvent) {
      return pointerEvent.button === 0;
    };

    /**
     * @param {ol.pointer.PointerEvent} pointerEvent Pointer event.
     * @private
     */
    ol.MapBrowserEventHandler.prototype.handlePointerDown_ =
        function(pointerEvent) {
      this.updateActivePointers_(pointerEvent);
      var newEvent = new ol.MapBrowserPointerEvent(
          ol.MapBrowserEvent.EventType.POINTERDOWN, this.map_, pointerEvent);
      this.dispatchEvent(newEvent);

      this.down_ = pointerEvent;

      Eif (!this.dragListenerKeys_) {
        /* Set up a pointer event handler on the `document`,
         * which is required when the pointer is moved outside
         * the viewport when dragging.
         */
        this.documentPointerEventHandler_ =
            new ol.pointer.PointerEventHandler(document);

        this.dragListenerKeys_ = [
          goog.events.listen(this.documentPointerEventHandler_,
              ol.MapBrowserEvent.EventType.POINTERMOVE,
              this.handlePointerMove_, false, this),
          goog.events.listen(this.documentPointerEventHandler_,
              ol.MapBrowserEvent.EventType.POINTERUP,
              this.handlePointerUp_, false, this),
          /* Note that the listener for `pointercancel is set up on
           * `pointerEventHandler_` and not `documentPointerEventHandler_` like
           * the `pointerup` and `pointermove` listeners.
           *
           * The reason for this is the following: `TouchSource.vacuumTouches_()`
           * issues `pointercancel` events, when there was no `touchend` for a
           * `touchstart`. Now, let's say a first `touchstart` is registered on
           * `pointerEventHandler_`. The `documentPointerEventHandler_` is set up.
           * But `documentPointerEventHandler_` doesn't know about the first
           * `touchstart`. If there is no `touchend` for the `touchstart`, we can
           * only receive a `touchcancel` from `pointerEventHandler_`, because it is
           * only registered there.
           */
          goog.events.listen(this.pointerEventHandler_,
              ol.MapBrowserEvent.EventType.POINTERCANCEL,
              this.handlePointerUp_, false, this)
        ];
      }
    };

    /**
     * @param {ol.pointer.PointerEvent} pointerEvent Pointer event.
     * @private
     */
    ol.MapBrowserEventHandler.prototype.handlePointerMove_ =
        function(pointerEvent) {
      // Fix IE10 on windows Surface : When you tap the tablet, it triggers
      // multiple pointermove events between pointerdown and pointerup with
      // the exact same coordinates of the pointerdown event. To avoid a
      // 'false' touchmove event to be dispatched , we test if the pointer
      // effectively moved.
      Iif (this.isMoving_(pointerEvent)) {
        this.dragging_ = true;
        var newEvent = new ol.MapBrowserPointerEvent(
            ol.MapBrowserEvent.EventType.POINTERDRAG, this.map_, pointerEvent,
            this.dragging_);
        this.dispatchEvent(newEvent);
      }

      // Some native android browser triggers mousemove events during small period
      // of time. See: https://code.google.com/p/android/issues/detail?id=5491 or
      // https://code.google.com/p/android/issues/detail?id=19827
      // ex: Galaxy Tab P3110 + Android 4.1.1
      pointerEvent.preventDefault();
    };

    /**
     * Wrap and relay a pointer event.  Note that this requires that the type
     * string for the MapBrowserPointerEvent matches the PointerEvent type.
     * @param {ol.pointer.PointerEvent} pointerEvent Pointer event.
     * @private
     */
    ol.MapBrowserEventHandler.prototype.relayEvent_ = function(pointerEvent) {
      var dragging = !!(this.down_ && this.isMoving_(pointerEvent));
      this.dispatchEvent(new ol.MapBrowserPointerEvent(
          pointerEvent.type, this.map_, pointerEvent, dragging));
    };

    /**
     * @param {ol.pointer.PointerEvent} pointerEvent Pointer event.
     * @return {boolean}
     * @private
     */
    ol.MapBrowserEventHandler.prototype.isMoving_ = function(pointerEvent) {
      return pointerEvent.clientX != this.down_.clientX ||
          pointerEvent.clientY != this.down_.clientY;
    };

    /**
     * @inheritDoc
     */
    ol.MapBrowserEventHandler.prototype.disposeInternal = function() {
      Eif (this.relayedListenerKey_) {
        goog.events.unlistenByKey(this.relayedListenerKey_);
        this.relayedListenerKey_ = null;
      }
      Eif (this.pointerdownListenerKey_) {
        goog.events.unlistenByKey(this.pointerdownListenerKey_);
        this.pointerdownListenerKey_ = null;
      }
      Iif (this.dragListenerKeys_) {
        this.dragListenerKeys_.forEach(goog.events.unlistenByKey);
        this.dragListenerKeys_ = null;
      }
      Iif (this.documentPointerEventHandler_) {
        goog.dispose(this.documentPointerEventHandler_);
        this.documentPointerEventHandler_ = null;
      }
      Eif (this.pointerEventHandler_) {
        goog.dispose(this.pointerEventHandler_);
        this.pointerEventHandler_ = null;
      }
      goog.base(this, 'disposeInternal');
    };

    /**
     * Constants for event names.
     * @enum {string}
     */
    ol.MapBrowserEvent.EventType = {

      /**
       * A true single click with no dragging and no double click. Note that this
       * event is delayed by 250 ms to ensure that it is not a double click.
       * @event ol.MapBrowserEvent#singleclick
       * @api stable
       */
      SINGLECLICK: 'singleclick',

      /**
       * A click with no dragging. A double click will fire two of this.
       * @event ol.MapBrowserEvent#click
       * @api stable
       */
      CLICK: goog.events.EventType.CLICK,

      /**
       * A true double click, with no dragging.
       * @event ol.MapBrowserEvent#dblclick
       * @api stable
       */
      DBLCLICK: goog.events.EventType.DBLCLICK,

      /**
       * Triggered when a pointer is dragged.
       * @event ol.MapBrowserEvent#pointerdrag
       * @api
       */
      POINTERDRAG: 'pointerdrag',

      /**
       * Triggered when a pointer is moved. Note that on touch devices this is
       * triggered when the map is panned, so is not the same as mousemove.
       * @event ol.MapBrowserEvent#pointermove
       * @api stable
       */
      POINTERMOVE: 'pointermove',

      POINTERDOWN: 'pointerdown',
      POINTERUP: 'pointerup',
      POINTEROVER: 'pointerover',
      POINTEROUT: 'pointerout',
      POINTERENTER: 'pointerenter',
      POINTERLEAVE: 'pointerleave',
      POINTERCANCEL: 'pointercancel'
    };